%bcond_without ksmarttray
%bcond_without smart_update

Name:		smart
Version:	0.52
Release:	%mkrel 5
Group:		System/Configuration/Packaging
Summary:	Next generation package handling tool
License:	GPLv2+
URL:		http://smartpm.org
Source0:	http://labix.org/download/smart/%{name}-%{version}.tar.bz2
Source1:	distro.i586
Source2:	%{name}.console
Source4:	%{name}-package-manager.desktop
Source6:	%{name}-newer.py
Source7:	%{name}-urpmi2smart.py
Patch0:		%{name}-trunk.patch
# Updated patch http://tracker.labix.org/file133/smart-show-changelog-2.patch
# http://tracker.labix.org/issue244
Patch1:		%{name}-show-changelog-2.patch
Patch2:		%{name}-0.42-platform.patch
Patch3:		%{name}-0.51-channel-mirrors.patch
Patch4:		%{name}-rpm-check-signatures.patch
Patch5:		%{name}-0.51-gtk-main-loop.patch
Patch6:		%{name}-0.51-ksmarttray.patch
Patch7:		%{name}-ksmarttray-runsmart.patch
# See <http://tracker.labix.org/issue320>
Patch12:	%{name}-0.51-ksmarttray-upgrade.patch
Patch8:		%{name}-0.51-use-pyc.patch
Patch10:	%{name}-0.51-fetcher-scp.patch
Patch11:	%{name}-0.51-add-smart-channel-desktop.patch
Patch13:	%{name}-0.51-detectsys.patch
# See <http://tracker.labix.org/issue327>
Patch14:	%{name}-0.51-slow-network.patch
# See <http://tracker.labix.org/issue310>
Patch15:	%{name}-0.51-pycurl-failonerror.patch
Patch16:	%{name}-0.51-hide-unlocked.patch
# See <http://tracker.labix.org/issue298>
Patch17:	%{name}-0.51-pycurl-slowdown.patch
# See <http://tracker.labix.org/issue313>
# ?

# (tpg) suse patches
Patch103:	%{name}-interactive-newer.patch
Patch104:	%{name}-no-strict-aliasing.patch
Patch105:	%{name}-0.52-termios-0width.patch
BuildRequires:	rpm-mandriva-setup
BuildRequires:	desktop-file-utils
Requires:	python-rpm
Requires:	usermode-consoleonly
%ifarch %{ix86}
Requires:	python-psyco
%endif
# (tpg) smart crashes while downloading hdlists
Conflicts:	python-curl
%py_requires -d
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
Smart Package Manager is a next generation package handling tool.

%files -f %{name}.lang
%defattr(0644,root,root,0755)
%doc HACKING README TODO IDEAS doc/*.css doc/*.html
%config(noreplace) %{_sysconfdir}/security/console.apps/smart-root
%config(noreplace) %{_sysconfdir}/pam.d/smart-root
%dir %{_libdir}/%{name}
%dir %{py_platsitedir}/smart
%dir %{_localstatedir}/smart/channels
%attr(0755,root,root)%{_bindir}/%{name}
%attr(0755,root,root)%{_bindir}/%{name}-root
%attr(0755,root,root) %{_bindir}/urpmi2smart
%{_libdir}/%{name}/distro.py
%{py_platsitedir}/smart/*
%exclude %{py_platsitedir}/smart/interfaces/gtk
%{py_platsitedir}/*.egg-info
%{_mandir}/*/*

#------------------------------------------------------------------

%package gui
Summary:	Smart GTK user interface
Group:		System/Configuration/Packaging
Requires(post):	desktop-file-utils
Requires(postun): desktop-file-utils
Requires:	%{name} = %{version}-%{release}
Requires:	pygtk2.0

%description gui
Smart GTK user interface.

%post gui
%{update_menus}
%{update_desktop_database}

%postun gui
%{clean_menus}
%{clean_desktop_database}

%files gui
%defattr(0644,root,root,0755)
%{_datadir}/applications/smart-package-manager.desktop
%{_datadir}/pixmaps/smart-package-manager.png
%{py_platsitedir}/smart/interfaces/gtk

#------------------------------------------------------------------

%if %with smart_update 
%package update
Summary:	Allows execution of 'smart update' by normal users (suid)
Group:		System/Configuration/Packaging
Requires:	%{name} = %{version}-%{release}

%description update
Allows execution of 'smart update' by normal users through a
special suid command.

%files update
%attr(4755,root,root) %{_bindir}/smart-update
%endif

#------------------------------------------------------------------

%if %with ksmarttray
%package -n ksmarttray
Summary:	KDE tray program for watching updates with Smart Package Manager
Group:		System/Configuration/Packaging
Requires(post):	desktop-file-utils
Requires(postun): desktop-file-utils
Requires:	%{name}-update = %{version}-%{release}
BuildRequires:	kdelibs-devel
BuildRequires:	popt
BuildRequires:	rpm-devel
 
%description -n ksmarttray
KDE tray program for watching updates with Smart Package Manager.

%files -n ksmarttray
%defattr(-,root,root)
%{_bindir}/ksmarttray
%{_bindir}/kde_add_smart_channel.sh
%{_datadir}/apps/ksmarttray
%{_datadir}/applications/ksmarttray.desktop
%{_datadir}/apps/konqueror/servicemenus/add_smart_channel.desktop

%post -n ksmarttray
%{update_menus}
%{update_desktop_database}

%postun -n ksmarttray
%{clean_menus}
%{clean_desktop_database}

%endif

#------------------------------------------------------------------

%prep
%setup -q
%patch 
%patch1 -p0
%patch2 -p1 -b .platform
%patch3 -p1
%patch4
%patch5 -p1
%patch8 -p1
%patch10 -p1
%patch11 -p1
%patch13 -p1
#%patch14 -p1
# (tpg) smart crashes while downloading hdlists
#%patch15 -p1
%patch16 -p1
# (tpg) smart crashes while downloading hdlists
#%patch17 -p1

# (tpg) suse patches
%patch103
%patch104
%patch105 -p1

# ksmarttray patches
%patch6 -p1
%patch7 
%patch12 -p1

%build
# (tpg) do not hardcode libdir
perl -pi -e 's,/usr/lib/%{name},%{_libdir}/%{name},g' smart/const.py

export CFLAGS="%{optflags}"
export CXXFLAGS="%{optflags}"

%make

%if %with ksmarttray
pushd contrib/ksmarttray
make -f admin/Makefile.common

%configure2_5x \
        %if "%{_lib}" == "lib64"
            --enable-libsuffix=64 \
        %endif
        --disable-rpath

%make
popd
%endif

%if %with smart_update 
pushd contrib/smart-update
%make
popd
%endif

%install
rm -fr %{buildroot}
%makeinstall_std

mkdir -p %{buildroot}%{_libdir}/smart

%ifnarch %{ix86}
%{__sed} -e 's/i586/%{_arch}/g;' < %{SOURCE1} > %{buildroot}%{_libdir}/smart/distro.py
%else
%{__cp} -a %{SOURCE1} %{buildroot}%{_libdir}/smart/distro.py
%endif

mkdir -p %{buildroot}%{_sysconfdir}/security/console.apps
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/security/console.apps/smart-root

ln -sf consolehelper %{buildroot}%{_bindir}/smart-root

mkdir -p %{buildroot}%{_sysconfdir}/pam.d

cat > %{buildroot}%{_sysconfdir}/pam.d/smart-root <<EOF
#%PAM-1.0
auth       sufficient   pam_rootok.so
auth       sufficient   pam_timestamp.so
auth       include      system-auth
account    required     pam_permit.so
session    required     pam_permit.so
session    optional     pam_timestamp.so
session    optional     pam_xauth.so
EOF

mkdir -p %{buildroot}%{_datadir}/applications
%{_bindir}/desktop-file-install \
        --dir %{buildroot}%{_datadir}/applications \
	%{SOURCE4}

mkdir -p %{buildroot}%{_datadir}/pixmaps
install -m 644 smart/interfaces/images/smart.png %{buildroot}%{_datadir}/pixmaps/smart-package-manager.png
mkdir -p %{buildroot}%{_localstatedir}/smart/channels

install -m 644 %{SOURCE6} %{buildroot}%{py_platsitedir}/%{name}/commands/newer.py

%{__mkdir_p} %{buildroot}%{_bindir}
%{__cp} -a %{SOURCE7} %{buildroot}%{_bindir}/urpmi2smart

%if %with smart_update 
pushd contrib/smart-update
cp -f smart-update %{buildroot}%{_bindir}
popd
%endif

%if %with ksmarttray
pushd contrib/ksmarttray
%makeinstall_std
popd

install -D -m 0755 contrib/servicemenus/kde_add_smart_channel.sh %{buildroot}%{_bindir}/kde_add_smart_channel.sh
%{__mkdir_p} %{buildroot}%{_datadir}/apps/konqueror/servicemenus
%{_bindir}/desktop-file-install \
        --dir %{buildroot}%{_datadir}/apps/konqueror/servicemenus \
        contrib/servicemenus/add_smart_channel.desktop

# XDG menu entry
mkdir -p %{buildroot}%{_datadir}/applications/
cat > ksmarttray.desktop << EOF
[Desktop Entry]
Name=KSmartTray
Comment=KDE Tray widget for updating RPM files
Exec=%{_bindir}/ksmarttray %%F
Icon=smart-package-manager
Type=Application
Categories=Qt;Settings;PackageManager;
EOF

%{_bindir}/desktop-file-install \
        --dir %{buildroot}%{_datadir}/applications  \
        ksmarttray.desktop
%endif

%find_lang %{name}

%clean
rm -rf %{buildroot}


%changelog
* Thu Jan 31 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 0.52-5mdv2008.1
+ Revision: 160889
- fix smart widht when running in terminal, patch 105

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Mon Dec 17 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.52-4mdv2008.1
+ Revision: 121130
- use SUSE patches
- drop patches 100-102
- rebuild for new rpm
- new license policy
- do not package LICENSE file

* Mon Oct 22 2007 David Walluck <walluck@mandriva.org> 0.52-3mdv2008.1
+ Revision: 101073
- always include ksmarttray patches in src.rpm
- always apply ksmarttray patches regardless of whether we are building it

* Thu Oct 18 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.52-2mdv2008.1
+ Revision: 99836
- drop patch 9 (merged in one SUSE patch)
- add three SUSE patches (x86_64 support)

* Tue Oct 09 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.52-1mdv2008.1
+ Revision: 96573
- remove patch 2 as it has been applied upstream
- new version
- *.pyc files should be shipped

* Thu Sep 27 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.51-17mdv2008.0
+ Revision: 93301
- do not hardcode libdir
- conflicts python-curl as it crashesh smart while updating channels
- do not ship *.pyc files
-  add full url for source0
- enable ksmarttray (somehow i just disabled it ;)
- use smart's makefile
- fix mixture of tabs and spaces
- do not use vendor in desktop files
- move patch 12 to ksmarttray section
- suggests python-curl

* Sat Sep 15 2007 David Walluck <walluck@mandriva.org> 0.51-16mdv2008.0
+ Revision: 85891
- require smart = %%{version}-%%{release} from subpackages so we don't get breakage

* Sat Sep 15 2007 David Walluck <walluck@mandriva.org> 0.51-15mdv2008.0
+ Revision: 85877
- fix conflicts with gui subpackage

* Fri Sep 14 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.51-14mdv2008.0
+ Revision: 85627
- check rpm signatures and add default pgp keyserver
  provide patch 14, which prevents segfaults on slower connections
  provide patch 15, which add support for fail on curl authentification error
  provide patch 16, which add Hide-Unlocked option in View menu
  provide patch 17, which should haven't slowndown on curl downloading
  set requires on python-curl, especially useful for people using proxies

* Thu Sep 13 2007 Thierry Vignaud <tvignaud@mandriva.com> 0.51-13mdv2008.0
+ Revision: 85237
- bump conflicts in order to fix upgrade (#33465)

* Thu Sep 13 2007 David Walluck <walluck@mandriva.org> 0.51-12mdv2008.0
+ Revision: 84932
- bump release
- remove executable bit from smart-package-manager.desktop
- document some outstanding issues

* Thu Sep 13 2007 David Walluck <walluck@mandriva.org> 0.51-10mdv2008.0
+ Revision: 84913
- partial fix for upstream ksmarttray update bug
- fix for bug #28782 (detectsys)

* Sun Sep 09 2007 David Walluck <walluck@mandriva.org> 0.51-9mdv2008.0
+ Revision: 83949
- include modified urpmi2smart.py script
- replace references to i568 with i586 in distro.i586
- always include distro.i586 as a source regardless of arch and update at install time
- use %%bcond_without macros for spec options
- add patch to fix downloading over scp
- use desktop-file-install and make sure .desktop files validate
- show ksmarttray in menus

  + Tomasz Pawel Gajc <tpg@mandriva.org>
    - update channel list
      remove JPackage because it is dead
      add non-free channel
      provide separate channel list for i586 and x86_64

* Mon Sep 03 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.51-6mdv2008.0
+ Revision: 78579
- use script fo find translations
- remove options for older mdv release
- drop exclude for some files
- ksmarttray will be shown only in KDE menus

* Wed Aug 29 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.51-5mdv2008.0
+ Revision: 74263
- remove doubled/unneeded buildrequires
- do not use  %%{_sourcedir}
- remove %%ifarch, rely on libsuffix for configure script
- small cleans in a spec file
- drop source 5 (smart has french translation already)
- provide patch 8 (fixes gui)
- provide patch 9 (speed up listing packages in channels)
- provide patch 5 (should speed up gui responsiveness)

* Tue Aug 28 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.51-4mdv2008.0
+ Revision: 72632
- fix build on x86_64
- provides smart newer, a command which shows packages that have available upgrades
- add ksmarttray's konqueror service menus
- add scriplets
- provide patch 4, which adds handling of rpm gpg signatures
- provide patch 3 (mirrors for channels)
- provide patch 2 (should speed up cache loading)
- provide patch 7 (ksmarttray can start smart-gui now)

* Fri Aug 10 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.51-3mdv2008.0
+ Revision: 61015
- provide patch 6 (enable build of ksmarttray)
- drop X-MandrivaLinux from desktop file

* Mon Jun 11 2007 Olivier Thauvin <nanardon@mandriva.org> 0.51-2mdv2008.0
+ Revision: 37984
- rebuild for rpm

* Mon May 21 2007 Andreas Hasenack <andreas@mandriva.com> 0.51-1mdv2008.0
+ Revision: 29383
- updated to version 0.51
- removed patches that were already included

* Wed May 02 2007 Funda Wang <fundawang@mandriva.org> 0.50-5mdv2008.0
+ Revision: 20377
- Move translations into main package, because vt under x11 may need
  translations.


* Wed Mar 28 2007 Andreas Hasenack <andreas@mandriva.com> 0.50-4mdv2007.1
+ Revision: 149279
- change back to root's password (#29858)

* Tue Mar 20 2007 Andreas Hasenack <andreas@mandriva.com> 0.50-3mdv2007.1
+ Revision: 146951
- simplify menu: only one entry
- ask for user password instead of root password, inline with
  the rpmdrake recent changes

* Thu Jan 25 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.50-2mdv2007.1
+ Revision: 113249
- bump release tag
- update patch 4

  + Nicolas Lécureuil <neoclust@mandriva.org>
    - New version 0.50

* Fri Dec 29 2006 Helio Chissini de Castro <helio@mandriva.com> 0.50-1.rc1.3mdv2007.1
+ Revision: 102610
- Changelog patch for installed packages. Patch from labix.org

* Tue Nov 28 2006 Andreas Hasenack <andreas@mandriva.com> 0.50-1.rc1.2mdv2007.1
+ Revision: 87872
- add egg-info file
- using (possibly) new policy for release numbering
- rebuild with python 2.5

* Tue Nov 14 2006 Andreas Hasenack <andreas@mandriva.com> 0.50-1.rc1.1mdv2007.1
+ Revision: 84162
- fix backtrace in ETA code with slow links

* Tue Nov 07 2006 Nicolas Lécureuil <neoclust@mandriva.org> 0.50-0.rc1.1mdv2007.0
+ Revision: 77069
- New version 0.50Rc1

* Thu Nov 02 2006 Michael Scherer <misc@mandriva.org> 0.42-7mdv2007.1
+ Revision: 75177
- Increment release
- fix desktop file ( according to desktop-file-validate )
- fix build with newer autoconf 2.6

* Thu Sep 07 2006 Andreas Hasenack <andreas@mandriva.com> 0.42-6mdv2007.0
+ Revision: 60276
- drop non-root menu entry (#25257)

* Wed Sep 06 2006 Andreas Hasenack <andreas@mandriva.com> 0.42-5mdv2007.0
+ Revision: 60074
- bumped release
- fixed syntax error in menu file
- escape macro in desktop files

* Fri Sep 01 2006 Andreas Hasenack <andreas@mandriva.com> 0.42-4mdv2007.0
+ Revision: 59253
- bump release
- fix build on i586/x86_64
- fixed #23751 (smart does not recognize a conflict when it should)

* Sat Aug 26 2006 Thierry Vignaud <tvignaud@mandriva.com> 0.42-3mdv2007.0
+ Revision: 58070
- fix incoherent-package-value-in-menu warning
- fix non-coherent-menu-filename warning
- XDG menu entry
- fix build on x86_64

  + Andreas Hasenack <andreas@mandriva.com>
    - update release :(
    - drop pam_stack, make build backportable
    - renamed mdv to packages because mdv is too generic and it's hosting only packages anyway
    - dummy commit
    - disable parallel build, it's not NFS friendly
    - replace %%{py_sitedir} with %%{py_platsitedir}: fixes build on x86_64
      (smart does have a few binary objects [.so], so it makes sense)
    - updated to version 0.40
    - releasing 0.40-1mdk
    - updated to version 0.39 (fixes #17385)
    - applied changes which were done only in cvs:
      - New upstream bugfix release: 0.38 (chiquitto@mandriva.com>
      - Patch0 was merged, remove it (chiquitto@mandriva.com)
      - Patch0: fix bug 17776: smart-update segfaults at startup (rgarciasuarez@mandriva.com)
      - Source5: fix French translations (rgarciasuarez@mandriva.com)
    - removed changelog from specfile in svn, repsys adds it back at package
      build time

  + Helio Chissini de Castro <helio@mandriva.com>
    - New upstream version 0.42
    - Removed defencondig patch already applied on code
    - Added old debian menu entry ( http://qa.mandriva.com/show_bug.cgi?id=19030 )
    - New upstream version. Major speed increase
    - Missing build requires
    - Added language exception patch from Bogdano
    - ksmarttray was disabled by mistake.
    - Separate gui from main package. Using smart as a command line must not require
      an entire set of xorg libs plus gtk base libs
    - Add build requires for rpm-mandriva-setup >= 17.1 to allow use of easy python macros
      introduced on latest rpm-mandriva-setup
    - Reenabled gpg signatire check ( Thanks Andreas )
    - Small changelog fix
    - Small changelog fix
    - Added changelog in package for moment
    - New upstream bugfix version
    - Package now have his home on subversion too
    - Uploading package ./smart

  + Michael Scherer <misc@mandriva.org>
    - add a ksmarttray menu file, bug 15551
    - fix menu file, not restricted to gnome or kde
    - remove application/x-urpmi mimtype handling, not used at the moment, reenable it if needed
    - use mkrel macro (for branding, backporting, etc)

* Thu Mar 24 2005 Helio Chissini de Castro <helio@mandrakesoft.com> 0.30-1mdk
- Changed spec layout and add the ability to generates just smart utilty
- Search option now available to regular users
- provides: path: requires: methods are available, allowing usual mdk devel
  requires match
- config is no longer available on package, as smart is in charge of handle this
  file now
- andreas: moved other changelog entries to here to avoid date problem ordering
  in this %%changelog section (these changes were done out of sync with the
  svn repository, i.e., the package was already in svn but changes were done
  to cvs)
  * Fri Jun 17 2005 Gustavo Niemeyer <gustavo@niemeyer.net> 0.36-1mdk 
  - New upstream version: 0.36

  * Mon May 30 2005 Helio Chissini de Castro <helio@mandriva.com> 0.35-2mdk
  - Added modifications from last package

  * Mon May 30 2005 Helio Chissini de Castro <helio@mandriva.com> 0.35-1mdk
  - New upstream version

  * Tue Mar 29 2005 Helio Chissini de castro <helio@mandrakesoft.com> 0.30.2-1mdk
  - Fixed minor flaw introduced by latest package

  * Tue Mar 29 2005 Helio Chissini de castro <helio@mandrakesoft.com> 0.30.1-1mdk
  - Minor fix for Python 2.3 backports

* Wed Mar 16 2005 Rafael Garcia-Suarez <rgarciasuarez@mandrakesoft.com> 0.29.2-2mdk
- amd64 compilation fix (by trem)

* Mon Mar 07 2005 Rafael Garcia-Suarez <rgarciasuarez@mandrakesoft.com> 0.29.2-1mdk
- New version
- Remove patch2, integrated upstream

* Fri Mar 04 2005 Laurent MONTEL <lmontel@mandrakesoft.com> 0.29-3mdk
- Patch2: fix qtooltips, remove it before to add it.

* Fri Mar 04 2005 Laurent MONTEL <lmontel@mandrakesoft.com> 0.29-2mdk
- Patch1: Includemoc into ksmarttray

* Wed Mar 02 2005 Rafael Garcia-Suarez <rgarciasuarez@mandrakesoft.com> 0.29-1mdk
- 0.29
- Require rpm-python for GUI
- Remove inter-package requires on release

* Wed Dec 08 2004 Rafael Garcia-Suarez <rgarciasuarez@mandrakesoft.com> 0.28-1mdk
- New version 0.28

* Mon Dec 06 2004 Rafael Garcia-Suarez <rgarciasuarez@mandrakesoft.com> 0.27.1-1mdk
- First Mandrakelinux package, based on Guilherme Manika's FC3 spec file,
  with the help of Michael Scherer.

